                          .model large,pascal
                          locals @@

                          .code MOU_TEXT
                          assume cs:MOU_TEXT, ds:MOU_TEXT
;ࠧ ᨬ   0B0h ''
Data_1                    db 88h,22h,88h,22h,88h,22h,88h,22h
                          db 88h,22h,88h,22h,88h,22h,88h,22h

ORMask                    db 00h,40h,60h,70h,78h,7Ch,7Eh,7Eh
                          db 78h,4Ch,0Ch,04h,06h,06h,00h,00h

ANDMask                   db 3Fh,5Fh,6Fh,77h,7Bh,7Dh,7Eh,7Eh
                          db 79h,4Dh,2Dh,0F4h,0F6h,0F6h,0F0h,0FFh

CharGenBuffer             db 4*19 dup(?)

PortFlags                 dw 0E06h
VisibleCount              dw 0
VideoSeg                  dw 0B800h
VideoOffset               dw 0
XMouse                    dw 0
YMouse                    dw 0
Keys                      dw 0
XMouse2                   dw 0
YMouse2                   dw 0
BytesPerChar              db 0
ScreenRows                db 0
ScreenColumns             db 0
ScrWidthInBytes           dw 0
ScrWidthInPixels          dw 0
ScrHeightInPixels         dw 0
CoordXMax                 dw 0
CoordXMin                 dw 0
CoordYMax                 dw 0
CoordYMin                 dw 0
TopScrMargin              dw 0
LeftScrMargin             dw 0
LastHorizDist             dw 0
LastVertDist              dw 0
CharCodeBuff1             dw ?
CharCodeBuff2             dw ?
FontCode                  db 0D1h,0D2h,0D3h,0D4h
PosInCell                 db ?

                        ;.code

public SetHandler,DisplayPointer,HidePointer,SetHandler,ResetHandler
public CorrectChar,CheckMouse,CheckAdapter,LocatePointer,SetRange
public InitMouse,GetXCoord,GetYCoord,GetKeys

GetXCoord               proc
                         mov    ax,cs:[XMouse]
                         ret
                        endp

GetYCoord               proc
                         mov    ax,cs:[YMouse]
                         ret
                        endp

GetKeys                 proc
                         mov    ax,cs:[Keys]
                         ret
                        endp

SetHandler              proc
                         push   ds
                         push   es
                         push   di
                         push   si
                         push   bp
                         push   cs
                         pop    ds
                         push   cs
                         pop    es
                         mov    cx,001Fh
                         mov    dx,offset mouse_handler ;es:dx=>handler
                         mov    ax,000Ch
                         int    33h
                         mov    ax,000Bh
                         int    33h
                         pop    bp
                         pop    si
                         pop    di
                         pop    es
                         pop    ds
                         ret
                        endp

DisplayPointer          proc
                         push   ds
                         push   es
                         push   di
                         push   si
                         push   bp
                         cli
                         push   cs
                         pop    ds
                         cmp    word ptr [VisibleCount],0
                         je     @@1
                         inc    word ptr [VisibleCount]
                         cmp    word ptr [VisibleCount],0
                         jne    @@1
                         call   ShowMouseCursor
                    @@1: sti
                         pop    bp
                         pop    si
                         pop    di
                         pop    es
                         pop    ds
                         ret
                        endp

HidePointer             proc
                         push   ds
                         push   di
                         cli
                         push   cs
                         pop    ds
                         dec    word ptr [VisibleCount]
                         cmp    word ptr [VisibleCount],-1
                         jne    @@1
                         mov    dx,[XMouse2]
                         mov    bx,[YMouse2]
                         call   HideMouseCursor
                    @@1: sti
                         pop    di
                         pop    ds
                         ret
                        endp

InitMouse               proc
                         push   ds
                         push   es
                         push   di
                         push   si
                         push   bp
                         push   cs
                         pop    ds
                         mov    [Keys],0
                         xor    bh,bh
                         mov    ax,1130h
                         int    10h
                         mov    [BytesPerChar],cl
                         push   cx
                         mov    [ScreenRows],dl
                         mov    ax,cx
                         mul    dl
                         add    ax,cx
                         sub    ax,6
                         mov    [ScrHeightInPixels],ax  ;ax= ࠭  ᪠-ப
                         mov    [CoordYMax],ax
                         xor    cx,cx
                         mov    [TopScrMargin],cx
                         mov    [CoordYMin],cx
                         shr    ax,1
                         mov    [YMouse2],ax
                         mov    [YMouse],ax
                         mov    ah,0Fh
                         int    10h
                         mov    cl,ah        ;ah=ScreenColumns
                         cmp    al,07h       ;al=VideoMode
                         jne    @@1
                         mov    si,0B000h
                         mov    [VideoSeg],si
                         mov    si,0A06h
                         mov    [PortFlags],si
                   @@1:
                         mov    al,ah
                         xor    ah,ah
                         add    ax,ax
                         mov    [ScrWidthInBytes],ax
                         mul    dl        ;ScreenRows
                         mul    bh        ;DisplayPage
                         mov    [VideoOffset],ax
                         dec    cl        ;ScreenColumns
                         mov    [ScreenColumns],cl
                         mov    ax,8
                         mul    cl
                         add    ax,5
                         mov    [ScrWidthInPixels],ax  ;ScreenColumns*8=ScrWidthInPixels
                         mov    [CoordXMax],ax         ;ScreenColumns*8
                         xor    cx,cx
                         mov    [LeftScrMargin],cx
                         mov    [CoordXMin],cx
                         shr    ax,1
                         mov    [XMouse2],ax
                         mov    [XMouse],ax
                         mov    di,offset CharGenBuffer
                         push   ds
                         push   ds
                         pop    es
                         mov    bl,[BytesPerChar]
                         xor    bh,bh
                         mov    ax,0A000h
                         mov    ds,ax
                         call   @PortProgr1
                         mov    dx,word ptr es:[FontCode]
                         call   SaveTwoCharImage
                         mov    dx,word ptr es:[FontCode+2]
                         call   SaveTwoCharImage
                         call   @PortProg2
                         pop    ds
                         mov    ax,000Bh
                         int    33h
                         mov    word ptr [VisibleCount],-1
                         pop    ax
                         pop    bp
                         pop    si
                         pop    di
                         pop    es
                         pop    ds
                         ret
                        endp

ResetHandler            proc
                         push   ds
                         push   es
                         push   di
                         push   si
                         push   bp
                         push   cs
                         pop    ds
                         xor    cx,cx
                         mov    ax,000Ch
                         int    33h
                         cmp    word ptr [VisibleCount],0
                         jne    @@1
                         mov    dx,[XMouse2]
                         mov    bx,[YMouse2]
                         call   HideMouseCursor
                    @@1: mov    si,offset CharGenBuffer
                         mov    dx,0A000h
                         mov    es,dx
                         mov    bl,[BytesPerChar]
                         sub    bh,bh
                         call   @PortProgr1
                           mov    dx,word ptr [FontCode]
                           call   PutTwoCharImage
                           mov    dx,word ptr [FontCode+2]
                           call   PutTwoCharImage
                         call   @PortProg2
                         pop    bp
                         pop    si
                         pop    di
                         pop    es
                         pop    ds
                         ret
                        endp

LocatePointer           proc   X:word, Y:word
                         push   si
                         push   di
                         push   ds
                         push   es
                         push   cs
                         pop    ds
                         mov    ax,[X]
                         mov    bx,[Y]
                         call   MoveCursorTo
                         pop    es
                         pop    ds
                         pop    di
                         pop    si
                         ret
                        endp

SetRange                proc   Xmin,Ymin,Xmax,Ymax
                         push   si
                         push   di
                         push   ds
                         push   es
                         push   cs
                         pop    ds
                         mov    ax,[Xmax]
                         mov    cx,[Xmin]
                         push   bp
                         call   SetXRange
                         pop    bp
                         mov    ax,[Ymax]
                         mov    cx,[Ymin]
                         call   SetYRange
                         pop    es
                         pop    ds
                         pop    di
                         pop    si
                         ret
                        endp

CheckMouse              proc
                         push   ds
                         xor    ax,ax
                         mov    ds,ax       ;ds=0000
                         cmp    word ptr ds:[33h*4],ax
                         jne    @@1
                         cmp    word ptr ds:[33h*4+2],ax
                         je     @@2
                    @@1: lds    bx,dword ptr ds:[33h*4]
                         cmp    byte ptr [bx],0CFh ;஢ઠ  IRET
                         je     @@2
                         inc    ax
                    @@2: pop    ds
                         ret
                        endp


CheckAdapter            proc
                         xor    bx,bx
                         mov    ax,1A00h
                         int    10h
                         cmp    al,1Ah
                         jne    @@1
                         cmp    bl,07
                         je     @@2
                         cmp    bl,08
                         je     @@2
                    @@1: mov    bl,10h
                         mov    ah,12h
                         int    10h
                         cmp    bl,10h
                         je     @@3
                         push   ds
                         mov    ax,0040h
                         mov    ds,ax
                         test   byte ptr ds:[87h],08
                         pop    ds
                         jne    @@4
                    @@3: xor    ax,ax
                         jmp    @@5
                    @@4: mov    ax,0001
                         jmp    @@5
                    @@2: mov    ax,0002
                    @@5: ret
                        endp

CorrectChar             proc
                         push   ds
                         push   es
                         push   si
                         push   di
                         push   cs
                         pop    ds
                         call   @PortProgr1
                         mov    di,0B0h*32   ; 1600h     ;?????????????????
                         mov    si,offset Data_1
                         mov    ax,0A000h
                         mov    es,ax
                         mov    cl,[BytesPerChar]
                         xor    ch,ch
                         rep    movsb
                         call   @PortProg2
                         pop    di
                         pop    si
                         pop    es
                         pop    ds
                         ret
                        endp

@PortProgr1             proc near
                         mov    dx,03C4h
                         mov    ax,0402h
                         out    dx,ax
                         mov    ax,0704h
                         out    dx,ax
                         mov    dx,03CEh
                         mov    ax,0005h
                         out    dx,ax
                         mov    ax,0406h
                         out    dx,ax
                         mov    ax,0204h
                         out    dx,ax
                         ret
                        endp

@PortProg2              proc near
                         mov    dx,03C4h
                         mov    ax,0302h
                         out    dx,ax
                         mov    ax,0304h
                         out    dx,ax
                         mov    dx,03CEh
                         mov    ax,1005h
                         out    dx,ax
                         mov    ax,[PortFlags]
                         out    dx,ax
                         mov    ax,0004h
                         out    dx,ax
                         ret
                        endp

;뫠 ࠧ ᨬ AL   ᨬ BL  
;BP=ࠧ ࠧ ᨬ   (BytesPerChar)
;DS=ES=0A000h
; DX,CX,SI,DI
CopyCharImage          proc near
                         mov    dl,al   ; si:=al*32
                         sub    dh,dh   ; di:=bl*32
                         mov    cl,5    ; cx:=bp
                         shl    dx,cl   ; rep movsb
                         mov    si,dx
                         mov    dl,bl
                         sub    dh,dh
                         shl    dx,cl
                         mov    di,dx
                         mov    cx,bp
                         rep    movsb
                         ret
                       endp

  ;뫠 ࠧ ᨬ AL   ᨬ BL  
  ;뫠 ࠧ ᨬ AH   ᨬ BH  
  ;BP=ࠧ ࠧ ᨬ   (BytesPerChar)
  ;DS=ES=0A000h
  ; DX,SI,DI
CopyTwoCharImage        proc near
                         push   cx
                         call   CopyCharImage
                         push   dx
                         mov    al,ah
                         mov    bl,bh
                         call   CopyCharImage
                         mov    di,dx
                         pop    si
                         pop    cx
                         ret
                        endp

      ; DH = Ycoord / BytesPerChar
      ;[PosInCell] ; ⮪ ।饣 
      ; DL = Xcoord / 8
CalcScreenAddr          proc near
                         push   bx
                         push   ax
                         mov    ax,[ScrWidthInBytes]
                         mul    dh   ;YC*Width+XC*2
                         mov    di,dx
                         and    di,00FFh
                         add    di,di
                         add    di,ax
                         add    di,[VideoOffset]
                         mov    ax,[VideoSeg]
                         mov    es,ax
                         pop    ax    ;ES:DI=>   
                         pop    bx    ; 
                         ret
                       endp

  ;࠭塞 ᮤন  
  ;DH=YC
  ;DL=XC
SaveCharsFromVideoBuff  proc near
                         call   CalcScreenAddr  ; 塞 
                         mov    al,es:[di]      ;  ᮤন 
                         mov    ah,es:[di+02]   ; ( ᬥ ᨬ)
                         mov    [CharCodeBuff1],ax   ; ࠭塞
                         add    di,[ScrWidthInBytes] ;६頥  ᫥.ப
                         mov    al,es:[di]      ;  ᬥ ᨬ
                         mov    ah,es:[di+02]
                         mov    [CharCodeBuff2],ax
                         ret
                        endp

;AL =  ࢮ ᨬ     AL  AH
;AH =  ண ᨬ     BL  BH
;BL =  쥣 ᨬ
;BH =  ⢥⮣ ᨬ
;DH=YC
;DL=XC
PutCharsToVideoBuff     proc near
                         call   CalcScreenAddr  ;塞 
                         mov    es:[di],al      ;뢠  ࢮ ᨬ
                         cmp    dl,[ScreenColumns] ;諨  ࠭  X?
                         je     @@1             ;
                         mov    es:[di+02],ah   ;뢠  ண ᨬ
                    @@1: cmp    dh,[ScreenRows] ;諨  ࠭  Y
                         je     @@2             ;
                         add    di,[ScrWidthInBytes] ;室  ᫥.ப
                         mov    es:[di],bl      ;堥   ᨬ
                         cmp    dl,[ScreenColumns]
                         je     @@2
                         mov    es:[di+02],bh
                    @@2: ret
                        endp

  ;  DX= Xcoord
  ;  BX= Ycoord
ConvertPixelsToCell    proc near
                         mov    cl,3
                         shr    dx,cl     ; Xcoord / 8
                         mov    cl,[BytesPerChar]
                         mov    ax,bx     ; Ycoord / BytesPerChar
                         div    cl
                         mov    dh,al     ; DH = Ycoord / BytesPerChar
                         mov    [PosInCell],ah ; ⮪ ।饣 
                         ret              ; DL = Xcoord / 8
                       endp

;뢠 ࠦ   ࠦ ४ ᨬ
MakeCursorView         proc near
                         push   dx
                         push   ds
                         push   bp
                         mov    bp,word ptr [BytesPerChar]
                         and    bp,00FFh
                         mov    dx,0A000h
                         mov    ds,dx
                         mov    es,dx
                         call   CopyTwoCharImage
                         pop    bp
                         pop    ds
                         pop    dx
                         add    si,dx
                         add    di,dx
                   @@1:  or     ch,ch
                         je     @@2
                         mov    ah,ds:ORMask[bp]
                         xor    al,al
                         mov    dh,ds:ANDMask[bp]
                         mov    dl,0FFh
                         shr    ax,cl
                         stc
                         rcr    dx,cl
                         and    es:[si],dh
                         and    es:[di],dl
                         or     es:[si],ah
                         or     es:[di],al
                         inc    bp
                         inc    si
                         inc    di
                         dec    ch
                         jmp    @@1
                   @@2:  ret
                        endp

  ;ᮢ    
ShowMouseCursor        proc near
                         mov    dx,[XMouse2]
                         mov    bx,[YMouse2]
                         push   dx
                         call   ConvertPixelsToCell
                         call   SaveCharsFromVideoBuff
                         pop    cx
                         and    cl,07
                         push   dx
                         call   @PortProgr1
                         mov    ax,[CharCodeBuff1]
                         mov    bx,word ptr [FontCode]
                         xor    bp,bp
                         mov    dl,[PosInCell]
                         xor    dh,dh
                         mov    ch,[BytesPerChar]
                         sub    ch,dl
                         call   MakeCursorView
                         mov    ax,[CharCodeBuff2]
                         mov    bx,word ptr [FontCode+2]
                         mov    ch,[PosInCell]
                         xor    dx,dx
                         call   MakeCursorView
                         call   @PortProg2
                         pop    dx
                         mov    ax,word ptr [FontCode]
                         mov    bx,word ptr [FontCode+2]
                         call   PutCharsToVideoBuff
                         ret
                        endp

  ;   ண    XMouse, YMouse
  ;  DX = XMouse2
  ;  BX = YMouse2
HideMouseCursor        proc near
                         call   ConvertPixelsToCell
                         mov    ax,[CharCodeBuff1]
                         mov    bx,[CharCodeBuff2]
                         call   PutCharsToVideoBuff
                         ret
                        endp

  ;࠭ ࠧ ᨬ  
  ;:   DS=VideoSeg
  ;      BX=᫮   뫪=BytesPerChar
  ;      AL= ᨬ
  ;      ES:DI=>  ࠧ ᨬ
SaveCharImage          proc near
                         sub    ah,ah
                         mov    cl,05
                         shl    ax,cl
                         mov    si,ax
                         mov    cx,bx
                         rep movsb
                         ret
                       endp

 ;࠭ ࠧ  ᨬ  
 ;:    DS=VideoSeg
 ;       BX=᫮   뫪=BytesPerChar
 ;       DL,DH= ᨬ
 ;       ES:DI=>  ࠧ ᨬ
SaveTwoCharImage       proc near
                         mov    al,dl
                         call   SaveCharImage
                         mov    al,dh
                         call   SaveCharImage
                         ret
                       endp

  ;頥 ࠧ ᨬ  
  ;:   ES=VideoSeg
  ;      BX=᫮   뫪=BytesPerChar
  ;      AL= ᨬ
  ;      DS:SI=> ࠧ ᨬ
PutCharImage            proc near
                         sub    ah,ah
                         mov    cl,05
                         shl    ax,cl
                         mov    di,ax
                         mov    cx,bx
                         rep movsb
                         ret
                        endp

  ;頥  ᨬ  
  ;: ES=VideoSeg
  ;    DS:SI=> ࠧ ᨬ
  ;    BX=BytesPerChar
  ;     DL=FontCode   ᨬ, ࠧ  㤥 饭
  ;     DH=FontCode+1
PutTwoCharImage        proc near
                         mov    al,dl
                         call   PutCharImage
                         mov    al,dh
                         call   PutCharImage
                         ret
                       endp

;ࠡ稪 뢠  
Mouse_Handler          proc far
                         push   ds
                         pushf
                         cld
                         cli
                         push   cs
                         pop    ds
                         mov    [Keys],bx          ; 
                         mov    dx,[LastHorizDist] ;।饥  
                         mov    bx,[LastVertDist]  ;
                         cmp    si,dx
                         jne    @@1
                         cmp    di,bx
                         je     @@exit
                    @@1: mov    [LastHorizDist],si
                         mov    [LastVertDist],di
                         sub    si,dx
                         sub    di,bx
                         mov    dx,[XMouse2]
                         mov    bx,[YMouse2]
                         push   dx
                         push   bx
                         add    dx,si
                         add    bx,di
                         cmp    dx,[CoordXMin]
                         jnl    @@2
                         mov    dx,[CoordXMin]
                    @@2: cmp    dx,[CoordXMax]
                         jle    @@3
                         mov    dx,[CoordXMax]
                    @@3: cmp    bx,[CoordYMin]
                         jnl    @@4
                         mov    bx,[CoordYMin]
                    @@4: cmp    bx,[CoordYMax]
                         jle    @@5
                         mov    bx,[CoordYMax]
                    @@5: mov    [XMouse2],dx
                         mov    [YMouse2],bx
                         mov    [XMouse],dx
                         mov    [YMouse],bx
                         pop    bx
                         pop    dx
                         cmp    word ptr [VisibleCount],0
                         jne    @@exit
                         call   HideMouseCursor
                         call   ShowMouseCursor
                    @@exit:
                         popf
                         pop    ds
                         retf
                        endp

;   AX= Xcoord
;   BX= Ycoord
SaveNewCoord           proc
                         mov    [XMouse2],ax
                         mov    [YMouse2],bx
                         mov    [XMouse],ax
                         mov    [YMouse],bx
                         ret
                       endp

;         AX= Xcoord
;         BX= Ycoord
MoveCursorTo            proc near
                         cmp    [CoordXMax],ax
                         jb     @@exit
                         cmp    ax,[CoordXMin]
                         jb     @@exit
                         cmp    [CoordYMax],bx
                         jb     @@exit
                         cmp    bx,[CoordYMin]
                         jb     @@exit
                         cmp    word ptr [VisibleCount],0
                         je     @@1
                         call   SaveNewCoord
                         jmp    @@exit
                    @@1:
                         push   ax
                         push   bx
                         mov    dx,[XMouse2]
                         mov    bx,[YMouse2]
                         call   HideMouseCursor       ;   ண 
                         pop    bx
                         pop    ax
                         call   SaveNewCoord
                         call   ShowMouseCursor       ;ᮢ    
                 @@exit: ret
                       endp

; AX= Xmax
; CX= Xmin
SetXrange               proc near
                         cmp    ax,cx
                         jnl    @@0
                         xchg   cx,ax
                    @@0: cmp    [ScrWidthInPixels],ax
                         jnb    @@1
                         mov    ax,[ScrWidthInPixels]
                    @@1: cmp    cx,[LeftScrMargin]
                         jnb    @@2
                         mov    cx,[LeftScrMargin]

                    @@2: mov    [CoordXMin],cx
                         mov    [CoordXMax],ax

                         cmp    ax,[XMouse2]
                         jnb    @@3
                         mov    bx,[YMouse2]
                         call   MoveCursorTo
                         jmp    @@4
                    @@3:
                         cmp    [XMouse2],cx
                         jnb    @@4
                         mov    bx,[YMouse2]
                         mov    ax,cx
                         call   MoveCursorTo
                   @@4:  ret
                        endp

; AX= Ymax
; CX= Ymin
SetYRange              proc near
                         cmp    ax,cx
                         jnl    @@0
                         xchg   cx,ax
                    @@0: cmp    [ScrHeightInPixels],ax
                         jnb    @@1
                         mov    ax,[ScrHeightInPixels]
                    @@1: cmp    cx,[TopScrMargin]
                         jnb    @@2
                         mov    cx,[TopScrMargin]

                    @@2: mov    [CoordYMin],cx
                         mov    [CoordYMax],ax
                         cmp    ax,[YMouse2]
                         jnb    @@3
                         mov    bx,ax
                         mov    ax,[XMouse2]
                         call   MoveCursorTo
                         jmp    @@4
                    @@3:
                         cmp    [YMouse2],cx
                         jnb    @@4
                         mov    ax,[XMouse2]
                         mov    bx,cx
                         call   MoveCursorTo
                   @@4:  ret
                        endp
                        end


